	;
	; Zeropage variables
	; Player values are written directly to these locations
	;
digi_base_1	= $10

digi_ptr_1	= digi_base_1 + $05
digi_ptr_2	= digi_base_1 + $08
digi_wavptr_lo	= digi_base_1 + $0E 
digi_ptr_1_lo	= digi_base_1 + $13
digi_speed_1_lo	= digi_base_1 + $15
digi_speed_1_hi	= digi_base_1 + $1B
digi_ptr_2_lo	= digi_base_1 + $25
digi_speed_2_lo	= digi_base_1 + $27
digi_speed_2_hi	= digi_base_1 + $2D
digi_save_a	= digi_base_1 + $38

digi_base_vars	= $4A

digi_chptr_1	= digi_base_vars + $0	; 16 bit
digi_chptr_2	= digi_base_vars + $2	; 16 bit
digi_note_len_1	= digi_base_vars + $4
digi_note_len_2	= digi_base_vars + $5
	;
	; *** INIT ***
	;
digi_init
	LDY #$00
	;
digi_speed
	LDX #$60			; digi speed
	;
	LDA $FF07
	AND #$40
	BEQ digi_pal
	;
	;LDX #$80			; digi speed for NTSC
digi_pal
	STX $FF00			; set digi speed
	STY $FF01
	;
	LDA #$A8			; enable timer
	STA $FF0A
	;  
	; -- Pre-read first notes for each channel
	;
	LDA #digi_channel_1 & 255	; reset channel pointers
	STA digi_chptr_1
	LDA #digi_channel_1 >> 8
	STA digi_chptr_1+1
	;
	LDA #digi_channel_2 & 255
	STA digi_chptr_2
	LDA #digi_channel_2 >> 8
	STA digi_chptr_2+1
	;
	LDA #$01
	STA digi_note_len_1
	STA digi_note_len_2
	;
	JSR DIGI_PLAYER
;	LDA (digi_chptr_1),y		; 1st byte: sample address high (or zero for repeat)
;	STA digi_ptr_1+2
;	STY digi_ptr_1+1		; low byte always zero
;	;
;	LDA (digi_chptr_2),y
;	STA digi_ptr_2+2
;	STY digi_ptr_2+1
;	;
;	INC digi_chptr_1
;	BNE *+4
;	INC digi_chptr_1+1
;	INC digi_chptr_2
;	BNE *+4
;	INC digi_chptr_2+1
;	;
;	LDA (digi_chptr_1),y		; 2nd byte: note length
;	STA digi_note_len_1
;	;
;	LDA (digi_chptr_2),y
;	STA digi_note_len_2
;	;
;	INC digi_chptr_1
;	BNE *+4
;	INC digi_chptr_1+1
;	INC digi_chptr_2
;	BNE *+4
;	INC digi_chptr_2+1
;	;
;	LDA (digi_chptr_1),y		; 3rd byte: sample speed (note)
;	TAX
;	LDA digi_freq_table_lo,x
;	STA digi_speed_1_lo+1
;	LDA digi_freq_table_hi,x
;	STA digi_speed_1_hi+1
;	;
;	LDA (digi_chptr_2),y
;	TAX
;	LDA digi_freq_table_lo,x
;	STA digi_speed_2_lo+1
;	LDA digi_freq_table_hi,x
;	STA digi_speed_2_hi+1
;	;
;	INC digi_chptr_1
;	BNE *+4
;	INC digi_chptr_1+1
;	INC digi_chptr_2
;	BNE *+4
;	INC digi_chptr_2+1
	;   
	; ==============
	;
	LDA #$FD;#$FD;!!!
	STA $FF0E
	LDA #$FD;#$FE;!!!
	STA $FF0F
	LDA #$03
	STA $FF10
	LDA $FF12
	ORA #$03
	STA $FF12
	;
	RTS
	;
	; *** PLAYER
	;	
DIGI_PLAYER
	DEC digi_note_len_1
	BNE dp_ch1_end 
	;
	LDY #$00
	;
	LDA #nyaaa			; for this channel, the sample never changes
	STA digi_ptr_1+2
	STY digi_ptr_1+1
	;   
dp_ch1_res	
	LDA (digi_chptr_1),y
	BNE dp_ch1_nores
	;
	LDA #digi_channel_1 & 255	; reset channel pointer 1
	STA digi_chptr_1
	LDA #digi_channel_1 >> 8
	STA digi_chptr_1+1
	;
	LDA (digi_chptr_1),y
	;
dp_ch1_nores
	STA digi_note_len_1
	;
	INC digi_chptr_1
	BNE *+4
	INC digi_chptr_1+1
	;
	LDA (digi_chptr_1),y
	TAX
	LDA digi_freq_table_lo,x
	STA digi_speed_1_lo+1
	LDA digi_freq_table_hi,x
	STA digi_speed_1_hi+1
	;
	INC digi_chptr_1
	BNE *+4
	INC digi_chptr_1+1
dp_ch1_end
	;
	; ----------------------------------
	;
	DEC digi_note_len_2
	BNE dp_ch2_end 
	;
dp_ch2_res	
	LDA (digi_chptr_2),y
	BNE dp_ch2_nores
	;
	LDA #digi_channel_2 & 255
	STA digi_chptr_2
	LDA #digi_channel_2 >> 8
	STA digi_chptr_2+1  
	;
	LDA (digi_chptr_2),y
	;
dp_ch2_nores
	STA digi_ptr_2+2
	STY digi_ptr_2+1
	;
	INC digi_chptr_2
	BNE *+4
	INC digi_chptr_2+1
	;               
	LDA #10	;#(digi_chptr_2),y	; for this channel, the speed never changes
	STA digi_note_len_2
	;
;	INC digi_chptr_2
;	BNE *+4
;	INC digi_chptr_2+1
	;
	LDA (digi_chptr_2),y
	TAX
	LDA digi_freq_table_lo,x
	STA digi_speed_2_lo+1
	LDA digi_freq_table_hi,x
	STA digi_speed_2_hi+1
	;
	INC digi_chptr_2
	BNE *+4
	INC digi_chptr_2+1
dp_ch2_end
	RTS

digi_freq_table_lo
	DB $80,$88,$90,$98,$a1,$ab,$b5,$c0,$cb,$d7,$e4,$f2,$00,$0f,$1f,$30,$43,$56,$6a,$80,$96,$af,$c8,$e3,$00
digi_freq_table_hi
	DB $00,$00,000,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$02		
	;
	; ### The IRQ (relocated to zero page)
	;
irq_digi
	STA digi_save_a		; +00 - (3) Save A - Address is fixed to (*) below
	;
	INC $FF09		; +02 - (6) Acknowledge IRQ
	;
;digi_ptr_1
	LDA $FFFF		; channel one
;digi_ptr_2
	ADC $FFFF		; plus channel two
	STA digi_wavptr_lo	; doesn't use Y!
	;
	LDA WavBits		; digi value lookup
	STA $FF11		; (4) set Volume: play digi
	;                 
	; ---
	;
;digi_ptr_1_lo
	LDA #$00		; channel 1 pointer increment (24 bit)
;digi_speed_1_lo
	ADC #$00		; carry is always clear
	STA digi_ptr_1_lo + 1
	LDA digi_ptr_1 + 1
;digi_speed_1_hi   
	ADC #$01
	STA digi_ptr_1 + 1
	LDA digi_ptr_1 + 2
	ADC #$00
	STA digi_ptr_1 + 2
	;
;digi_ptr_2_lo
	LDA #$00		; channel 2 pointer increment (24 bit)
;digi_speed_2_lo
	ADC #$00		; carry may not be clear, but does not make an audible difference
	STA digi_ptr_2_lo + 1
	LDA digi_ptr_2 + 1
;digi_speed_2_hi   
	ADC #$01
	STA digi_ptr_2 + 1
	LDA digi_ptr_2 + 2
	ADC #$00
	STA digi_ptr_2 + 2
	;
;digi_save_a
	LDA #$00		; (2) self-mod zero page code
	;
	RTI			; (6) avg IRQ call: (33) cycles
irq_digi_end	
	;
	; #####################
	;
 ; eof