	;
	; This small utility is a helper for the NyanCat demo.
	; The second part (upscroller) is encoded so that only half the bits of each byte are used.
	; This is done so that it can fit "into" the multicolor graphics.
	; Colors 0 and 3 (ff15/ff16) cannot be used, so only one color is used. 
	;
	; The flag byte is: $8A (10001010)
	;
	; Each byte is taken apart, and stored on two bytes like this:
	; 
	; original: ABCDEFGH encoded 1: A0C0E0G
	;                            2: B0D0F0H
	;
	
	ORG $0700-2
	DW $0700
	
beg_ptr	= $2B
end_ptr	= $2D

dst_beg	= $D0
dst	= $D2
	
	SEI
	STA $FF3F
	;
	LDA #$41
	STA $FF19
	;
	LDA #$00		; calc start of destination, save start address
	STA dst_beg
	STA dst
	LDA end_ptr+1
	CLC
	ADC #$01
	STA dst_beg+1
	STA dst+1
	;
main	LDA #$8A		; flag byte
	JSR store
	;
	LDY #$00		; encode 3 bytes
	LDA (beg_ptr),y
	JSR store_encoded
	;
	LDY #$01
	LDA (beg_ptr),y
	JSR store_encoded
	;
	LDY #$02
	LDA (beg_ptr),y
	JSR store_encoded
	;
	LDA #$00		; pad with zero
	JSR store
	;
	LDA beg_ptr			; +3 bytes
	CLC
	ADC #$03
	STA beg_ptr
	BCC *+4
	INC beg_ptr+1
	;
	LDA beg_ptr+1		; are we at the end?
	CMP end_ptr+1
	BCC main
	BEQ main
	;
	; ---
	;
	LDA dst_beg		; set start/end pointers (for easy YAPE saving)
	STA beg_ptr
	LDA dst_beg+1
	STA beg_ptr+1
	;
	LDA dst
	STA end_ptr
	LDA dst+1
	STA end_ptr+1
	;
	LDA #$55
	STA $FF19
	;
	JMP *
	;
store_encoded
	TAX
	AND #$AA
	JSR store
	;
	TXA
	ASL a
	AND #$AA
	;
store	LDY #$00
	STA (dst),y
	;
	LDA dst
	CLC
	ADC #$01
	STA dst
	BCC *+4
	INC dst+1
	RTS
;eof