	;
	; This utility convers a character screen
	; to a set of addresses.
	; The characters are checked from beginning to end
	; (first char 0, then A, B, C, etc. all the way to $FF)
	;
	; Between each set, $0000 will be placed.
	;
	ORG $0700-2
	DW $0700
	
dest = $1000			; store data from here
	
src	= $D0
dst	= $D2
char	= $D4
found	= $D5
	
	SEI
	;
	LDA #$31		; working gray
	STA $FF19
	;
	LDA #dest & 255		; set destination (also beginning of save)
	STA dst
	STA $2B
	LDA #dest >> 8
	STA dst+1
	STA $2C
	;
	LDX #$00
lchar	STX char
	;
	LDA #$00		; start from $0C00
	STA src
	LDA #$0C
	STA src+1
	;
	LDA #$00		; flag that we have not found any chars yet
	STA found
	;
	LDY #$00
l1	LDA (src),y
	CMP char
	BNE next
	;
	JSR store
	;
next	LDA src
	CLC
	ADC #$01
	STA src
	BCC *+4
	INC src+1
	;
	LDA src			; are we at $0FE8?
	CMP #$E8
	BNE l1
	LDA src+1
	CMP #$0F
	BNE l1
	;
	LDA found		; did we find any?
	BEQ none
	;
	LDA #$00		; yes, place $0000 flag between sets.
	JSR store_byte
	LDA #$00
	JSR store_byte
	;
none	INX
	BNE lchar
	;
	LDA dst			; set end address,
	STA $2D			; so resulting data of addresses can be saved from YAPE
	LDA dst+1
	STA $2E
	;
	LDA #$45		; green border = we're done
	STA $FF19
	JMP *

store
	LDA #$FF		; flag that we found at least one of this char
	STA found
	;
	LDA src			; store the pointer address
	JSR store_byte
	LDA src+1
	;	
store_byte
	STA (dst),y
	;
	LDA dst
	CLC
	ADC #$01
	STA dst
	BCC *+4
	INC dst+1
	RTS
;[eof]	